NFSDCTL(8)

NAME
nfsdctl - control program for the Linux kernel NFS server

SYNOPSIS

nfsdctl [ OPTION ] COMMAND ...

DESCRIPTION

nfsdctl is a control and query program for the in-kernel NFS server. There are several subcommands (documented below) that allow the admin to configure or query different aspects of the NFS server.

To get information about different subcommand usage, pass the subcommand the --help parameter. For example:

    nfsdctl listener --help

OPTIONS

-d, --debug
    Enable debug logging

-h, --help
    Print program help text

-s, --syslog
    Log to syslog instead of to stderr (the default)

-V, --version
    Print program version

SUBCOMMANDS

Each subcommand can also accept its own set of options and arguments. The --help option is standard for all subcommands:

autostart
    Start the server using the settings in the [nfsd] section of /etc/nfs.conf. This subcommand takes no arguments. Note that if a "threads=" value is not set in nfs.conf, 16 server threads will be brought online.

listener
    Get/set the listening sockets for the server. Run this without arguments to get a list of the sockets on which the server is currently listening. To add or remove sockets, pass it whitespace-separated strings in the format:

        { +|- }{ protocol }:{ address }:{ port }

        The fields are:

        + to add a listener, - to remove one
        protocol: protocol name (e.g. tcp, udp, rdma)
        address: hostname or address
        port: port number or service name

        All fields are required, except for the address. If address is an empty string,
        then the listeners will be opened for INADDR_ANY and IN6ADDR_ANY_INIT for ipv6
        (if enabled). The address can be either a hostname or an IP address. IPv4
        addresses must be in dotted-quad form. IPv6 addresses should be in standard
        colon separated form, and must be enclosed in square brackets.

nlm
    Get information about NLM (lockd) settings in the current net namespace. This subcommand takes no arguments.

status
    Get information about RPCs currently executing in the server. This subcommand takes no arguments.

threads
    Get/set the number of running nfsd threads in each pool. Pass a list of integers to change the currently active number of threads. Passing it a value of 0 will shut down the NFS server. Run this without arguments to get the current number of running threads in each pool.

    These options are specific to the "threads" subcommand:
    -m, --min-threads=
        If set to a positive, non-zero value, then dynamic threading is enabled for
        nfsd.  In this mode, the traditional "threads" values are treated as a maximum
        number of threads. This specifies the minimum number of threads per pool. The
        kernel will start the minimum number and dynamically start and stop threads as
        needed. If the minimum is larger than the maximum, then dynamic threadis is
        disabled, and the maximum number is started.

version
    Get/set the enabled NFS versions for the server. Run without arguments to get a list of supported versions and whether they are currently enabled or disabled. To enable or disable a version, pass it a string in the format:

        { +|- }{ MAJOR }{.{ MINOR }}

        The fields are:

        + to enable a version, - to disable
        MAJOR: the major version integer value
        MINOR: the minor version integer value

        The minorversion field is optional. If not given, it will disable or enable
        all minorversions for that major version.

        Note that versions can only be set when there are no nfsd threads running.

pool-mode
    Get/set the host’s pool mode. This will cause the server to start threads that are pinned to either the CPU or the NUMA node. This can only be set when there are no nfsd threads running.

        The available options are:
          global:  single large pool
          percpu:  pool per CPU
          pernode: pool per NUMA node
          auto:    choose a mode based on host configuration

EXAMPLES

Start the server with the settings in nfs.conf:

    nfsdctl autostart

Get a list of current listening sockets:

    nfsdctl listener

Show the supported and enabled NFS versions:

    nfsdctl version

Add TCP listener on all addresses (both v4 and v6), port 2049:

    nfsdctl listener +tcp::2049

Add RDMA listener on 1.2.3.4 port 20049:

    nfsdctl listener +rdma:1.2.3.4:20049

Add same listener on IPv6 address f00::ba4 port 20050:

    nfsdctl listener +rdma:[f00::ba4]:20050

Enable NFS version 3, disable v4.0:

    nfsdctl version +3 -4.0

Change the number of running threads in first pool to 256:

    nfsdctl threads 256

Set the pool-mode to "pernode":

    nfsdctl pool-mode pernode

NOTES

nfsdctl is intended to supersede rpc.nfsd(8), which controls the nfs server using the files under /proc/fs/nfsd. nfsdctl instead uses a netlink(7) interface to achieve the same goals.

Most of the commands that query the NFS server can be run as an unprivileged user, but configuring the server typically requires an account with elevated privileges.

SEE ALSO

nfs.conf(5), rpc.nfsd(8), rpc.mountd(8), exports(5), exportfs(8), rpc.rquotad(8), nfsstat(8), netconfig(5)

AUTHOR

Jeff Layton